#ifndef __GainBucket_h__
#define __GainBucket_h__

#include "IO.h"

typedef struct bucketentry
{
  long vtxnr ;            /* stores the vertexnumber for this bucketentry */
  struct bucket *bucket ; /* pointer to the bucket where this entry belongs to */
  struct bucketentry *prev ; /* pointer to previous bucketentry in the list */
  struct bucketentry *next ; /* pointer to next bucketentry in the list */
} BucketEntry ;

typedef struct bucket 
{
  long value ;           /* value for the entries in this bucket */
  struct bucket *prev ;  /* pointer to previous bucket in the list */
  struct bucket *next ;  /* pointer to next bucket in the list */
  struct bucketentry *entry ; /* pointer to first bucketentry in this bucket */
} Bucket ;

typedef struct gainbucket
{
  long NrBuckets ;       /* counts the number of buckets in the gainbucket */
  struct bucket *Root ;  /* pointer to the first bucket in the list */
} GainBucket ;


struct bucketentry *BucketInsert(struct gainbucket *pGB, long key, 
				 long VtxNr) ;

struct bucketentry *BucketMove(struct gainbucket *pGB, struct bucketentry *pE,
			       long key) ;

long GainBucketExtractMax(struct gainbucket *pGB) ;

long GainBucketGetMaxVal(struct gainbucket *pGB) ;

long GainBucketGetMaxValVertexNr(struct gainbucket *pGB) ;

void PrintBuckets(struct gainbucket GB) ;

void ClearGainBucket(struct gainbucket *pGB) ;

#endif /* __GainBucket_h__ */
