#include "IO.h" 

FILE *OpenFile(char *file_name, char *mode) {

    /* This function opens a file */

    FILE *stream ;
    if ( (stream = fopen(file_name, mode)) == NULL) {
        fprintf(stderr, "\nFILE_ERROR: Can't open file \"%s\"\n",
                file_name) ;
        Abort("OpenFile()") ;
    }
    return(stream) ;

} /* end OpenFile */


void CloseFile(char *file_name, FILE *stream) {

    /* This function closes a file */

    if ( fclose(stream) == EOF ) {
        fprintf(stderr, "\nFILE_ERROR: Can't close file \"%s\"\n", 
                file_name) ;
        Abort("CloseFile()") ;
    }

} /* end CloseFile */


void Abort(char *error) {

    /* This function aborts, rings the alarm bell (007),
       and writes an error message to stderr */ 

    if ( error != NULL )
        fprintf(stderr, "\nABORT: %s\007\n\n", error) ;
    fflush(stderr) ;
    exit(-1) ;

} /* end Abort */
